﻿Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ' Create a customer entity. If you're from the 90's, then hydrate 😲 the customer entity instead.
        Dim _Customer As Customer = New Customer() With {.Id = Guid.NewGuid, .Name = "Michael", .Address = "London", .JoinDate = Date.Now}
        Dim _ByteArray() As Byte = _Customer.Serialize()

        _Customer = Nothing                     ' Clear customer data.
        _Customer = New Customer(_ByteArray)    ' Recreate (re-hydrate 😆) customer from byte array.

        MessageBox.Show(_Customer.Name)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Dim _Customers As CustomerCollection = New CustomerCollection()

        _Customers.Add(New Customer() With {.Id = Guid.NewGuid, .Name = "Michael", .Address = "London", .JoinDate = Date.Now})
        _Customers.Add(New Customer() With {.Id = Guid.NewGuid, .Name = "Martin", .Address = "Paris", .JoinDate = Date.Now})
        _Customers.Add(New Customer() With {.Id = Guid.NewGuid, .Name = "Andrea", .Address = "Sydney", .JoinDate = Date.Now})
        _Customers.Add(New Customer() With {.Id = Guid.NewGuid, .Name = "Günter", .Address = "Tokyo", .JoinDate = Date.Now})
        _Customers.Add(New Customer() With {.Id = Guid.NewGuid, .Name = "Inge", .Address = "Johannesburg", .JoinDate = Date.Now})

        Dim _ByteArray() As Byte = _Customers.Serialize()

        _Customers = Nothing                                ' Clear customer list.
        _Customers = New CustomerCollection(_ByteArray)     ' Recreate (re-hydrate 😆) customer list from byte array.

        MessageBox.Show(_Customers(0).Name & " (" & _Customers.Count.ToString & " total customers)")

    End Sub

End Class
